/*
--------------------------------------------------------------------------------
				Surf Manager v 1.0				|
--------------------------------------------------------------------------------|
	This is a full Surfing Mod Manager for servers running Surf Mod.	|
	The plugin is active on surf maps only.					|
--------------------------------------------------------------------------------|
	Credits:								|
	FrostNades by XxAvalanchexX						|
	SyN Surf Jetpack by Cheap_Suit						|
	Free For All by ConnorMcLeod						|
--------				 ---------------------------------------|
	Big thank you to these scripters!					|
--------				 ---------------------------------------|
	Moddeler for player models: Small_sumo (small_sumo34@hotmail.com )	|
--------------------------------------------------------------------------------|
	Author: Dosyk.								|
--------------------------------------------------------------------------------
*/

#include <amxmodx>
#include <hamsandwich>
#include <cstrike>     
#include <fun>
#include <amxmisc>
#include <engine>
#include <fakemeta_util>
#include <fakemeta>
#include <nvault>

#define MEXIT_NEVER -1 
#define FREQ 0.1

#define message_begin_fl(%1,%2,%3,%4) engfunc(EngFunc_MessageBegin, %1, %2, %3, %4)
#define write_coord_fl(%1) engfunc(EngFunc_WriteCoord, %1)
//afk
#define MIN_AFK_TIME 30	
#define WARNING_TIME 15
#define CHECK_FREQ 5

//ConnorMcLeod FFA script
#define OFFSET_TEAM	114
#define fm_get_user_team(%1)	get_pdata_int(%1,OFFSET_TEAM)
#define fm_set_user_team(%1,%2)	set_pdata_int(%1,OFFSET_TEAM,%2)
//

#define PREFIX "!y[!gSurf Manager!y]"

#define m_pPlayer			41
#define m_pActiveItem		373
#define m_flFlashedUntil	514
#define m_flFlashHoldTime	517
#define OFFSET_WEAPON_CSWID	43

#define Ham_Player_ResetMaxSpeed Ham_Item_PreFrame

#define MAX_WEAPONS		32
#define AMMO_FLASHBANG		11
#define AMMO_HEGRENADE		12
#define AMMO_SMOKEGRENADE	13
#define DMG_GRENADE		(1<<24) // thanks arkshine
#define FFADE_IN			0x0000 // just here so we don't pass 0 into the function
#define BREAK_GLASS		0x01
#define STATUS_HIDE		0
#define STATUS_SHOW		1
#define STATUS_FLASH		2

#define GLOW_AMOUNT		1.0
#define FROST_RADIUS		240.0

#define NT_FLASHBANG		(1<<0) // 1; CSW:25
#define NT_HEGRENADE		(1<<1) // 2; CSW:4
#define NT_SMOKEGRENADE		(1<<2) // 4; CSW:9

new const GRENADE_NAMES[][] = {
	"weapon_hegrenade",
	"weapon_flashbang",
	"weapon_smokegrenade"
};

#define ICON_HASNADE		1
#define ICON_ISCHILLED		2

#define TASK_REMOVE_CHILL	100
#define TASK_REMOVE_FREEZE	200

new const MODEL_FROZEN[]	= "models/pi_shrub.mdl";
new const MODEL_GLASSGIBS[]	= "models/glassgibs.mdl";

new const SOUND_EXPLODE[]	= "x/x_shoot1.wav";
new const SOUND_FROZEN[]	= "debris/glass1.wav";
new const SOUND_UNFROZEN[]	= "debris/glass3.wav";
new const SOUND_CHILLED[]	= "player/pl_duct2.wav";
new const SOUND_PICKUP[]	= "items/gunpickup2.wav";

new const SPRITE_TRAIL[]	= "sprites/laserbeam.spr";
new const SPRITE_SMOKE[]	= "sprites/steam1.spr";
new const SPRITE_EXPLO[]	= "sprites/shockwave.spr";

new pcv_enabled, pcv_override, pcv_nadetypes, pcv_teams, pcv_limit, pcv_buyzone, pcv_color, pcv_icon,
		pcv_by_radius, pcv_hitself, pcv_los, pcv_maxdamage, pcv_mindamage, pcv_chill_maxchance, pcv_chill_minchance,
		pcv_chill_duration, pcv_chill_variance, pcv_chill_speed, pcv_freeze_maxchance, pcv_freeze_minchance,
		pcv_freeze_duration, pcv_freeze_variance;

new maxplayers, gmsgScreenFade, gmsgStatusIcon, gmsgBlinkAcct, gmsgAmmoPickup, gmsgTextMsg,
		gmsgWeapPickup, glassGibs, trailSpr, smokeSpr, exploSpr, mp_friendlyfire, czero, bot_quota, czBotHams, fmFwdPPT,
		fnFwdPlayerChilled, fnFwdPlayerFrozen, bool:roundRestarting;

new isChilled[33], isFrozen[33], frostKilled[33], novaDisplay[33], Float:glowColor[33][3], Float:oldGravity[33], oldRenderFx[33],
		Float:oldRenderColor[33][3], oldRenderMode[33], Float:oldRenderAmt[33], hasFrostNade[33], nadesBought[33];


new bool:plrInfo[33]

new TaskEnt,SyncHud, SyncHud2,showinfromer

new speed[33]
new hp[33]
new gravity[33]
new shop_hp[33]
new shop_mgun[33]
new shop_glock[33]
new team[33]
new teamka[33]
new allowed_now[33]
new igrok

new enable_teams
new enable_ffa
new price_jet
new price_hp
new price_glock
new price_minigun
new price_frost
new price_speed
new price_gravity
new hp_amount
new shop_enable

new pcv_hp
new pcv_team	
new pcv_score
new pcv_players


new VIEW_FROST[] = "models/frost/frost.mdl" 


new ok[33]

new g_Vault;               //Global var to hold our vault handle
new g_szAuthID[33][35];    //Global array to store auth ids of players

new score[33]

new SPRITE_MODEL[] 	= "sprites/explode1.spr"
new JETPACK_PMODEL[] 	= "models/p_longjump.mdl"
new JETPACK_GOTSOUND[] 	= "items/ammopickup2.wav"

new sprite_fire

new t_red
new t_blue
new t_green
new t_black

new red_score
new blue_score
new green_score
new black_score
new enable_dm

new arcade
new name[32]
new translit[33]
new MapName[33]
new g_HasJetpack[33]
new g_JetpackEnt[33]
new TouchWeapons[33]
new szTime[33] // регистрация переменной времени

public plugin_init() 
{
	register_plugin("Surf Manager", "1.0", "Dosyk")
	
	get_mapname(MapName,31)
	if(contain(MapName, "surf_") == -1) //If not a surf, than there's no point in running the plugin.
		return			    //Disabling...
	
	
	// Registering Language file
	register_dictionary( "surf_manager.txt" );
	
	register_clcmd("say /team", "team_menu", ADMIN_ALL,"Shows")
	register_clcmd("say_team /team", "team_menu", ADMIN_ALL,"Shows")
	
	register_clcmd( "joinclass", "cmdJoinClass" )

	register_clcmd("say_team /scout", "scout")
	register_clcmd("say /scout", "scout")

	register_clcmd("say /respawn", "yes")
	register_clcmd("say /spawn", "yes")
	register_clcmd("say_team /respawn", "yes")
	register_clcmd("say_team /spawn", "yes")

	register_clcmd("say /rules", "rules")
	register_clcmd("say_team /rules", "rules")

	register_clcmd("shop", "shop_menu")
	register_clcmd("say /shop", "shop_menu")
	register_clcmd("say_team /shop", "shop_menu")
	
	enable_teams = register_cvar( "enable_teams", "1" )
	enable_dm = register_cvar( "enable_deathmatch", "1" )
	enable_ffa = register_cvar( "enable_ffa", "1" )
	shop_enable = register_cvar( "shop_enable", "1" )
	price_jet = register_cvar( "jet_cost", "20" )
	price_hp = register_cvar( "hp_cost", "5" )
	hp_amount = register_cvar( "hp_amount", "255" )
	price_glock = register_cvar( "glock_cost", "15" )
	price_minigun = register_cvar( "minigun_cost", "25" )
	price_frost = register_cvar( "frost_cost", "10" )
	price_speed = register_cvar( "speed_cost", "7" )
	price_gravity = register_cvar( "gravity_cost", "7" )

	showinfromer = register_cvar("infrormer_enable", "1")
	pcv_hp = register_cvar("show_hp","1")
	pcv_score = register_cvar("show_score","1")
	pcv_team = register_cvar("show_team","1")	
	pcv_players = register_cvar("show_players","1")
	
	pcv_enabled = register_cvar("fn_enabled","1")
	pcv_override = register_cvar("fn_override","1")
	pcv_nadetypes = register_cvar("fn_nadetypes","4") // NT_SMOKEGRENADE
	pcv_teams = register_cvar("fn_teams","3")
	pcv_icon = register_cvar("fn_icon","1")
	pcv_limit = register_cvar("fn_limit","0")
	pcv_buyzone = register_cvar("fn_buyzone","1")
	pcv_color = register_cvar("fn_color","0 206 209")

	pcv_by_radius = register_cvar("fn_by_radius","0.0")
	pcv_hitself = register_cvar("fn_hitself","1")
	pcv_los = register_cvar("fn_los","1")
	pcv_maxdamage = register_cvar("fn_maxdamage","20.0")
	pcv_mindamage = register_cvar("fn_mindamage","1.0")
	pcv_chill_maxchance = register_cvar("fn_chill_maxchance","100.0")
	pcv_chill_minchance = register_cvar("fn_chill_minchance","100.0")
	pcv_chill_duration = register_cvar("fn_chill_duration","7.0")
	pcv_chill_variance = register_cvar("fn_chill_variance","1.0")
	pcv_chill_speed = register_cvar("fn_chill_speed","60.0")
	pcv_freeze_maxchance = register_cvar("fn_freeze_maxchance","110.0")
	pcv_freeze_minchance = register_cvar("fn_freeze_minchance","40.0")
	pcv_freeze_duration = register_cvar("fn_freeze_duration","4.0")
	pcv_freeze_variance = register_cvar("fn_freeze_variance","0.5")
	
	//ConnorMcLeod FFA

	RegisterHam(Ham_TraceAttack, "player", "TraceAttack")
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage")
	RegisterHam(Ham_Killed, "player", "Killed")

	//ConnorMcLeod FFA

	register_clcmd("give_score","give_score",ADMIN_RCON,"Gives score points <name or #userid> [amount]") 	

	RegisterHam(Ham_Touch, "weaponbox", "TouchWeapon")
	RegisterHam(Ham_Touch, "armoury_entity", "TouchWeapon")
	RegisterHam(Ham_Touch, "weapon_shield", "TouchWeapon")

	RegisterHam(Ham_TakeDamage, "player", "player_damage")
	RegisterHam(Ham_BloodColor, "player", "FwdPlayerBloodColorPre", 0)
	
	register_forward(FM_SetClientKeyValue, "set_client_kv")


	RegisterHam(Ham_Killed, "player", "Player_Death", 1)
	register_event("DeathMsg","DeathMsg","a")
	
	new iEntity = find_ent_by_class(-1, "player_weaponstrip")
	new iEntity2 = find_ent_by_class(-1, "game_player_equip")
	remove_entity(iEntity)
	remove_entity(iEntity2)

	register_think("speedometer_think", "Think")
	
	TaskEnt = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	
	set_pev(TaskEnt, pev_classname, "speedometer_think")
	set_pev(TaskEnt, pev_nextthink, get_gametime() + 1.01)
	
	register_clcmd("say /informer", "toogleInfo")
	register_clcmd("say_team /informer", "toogleInfo")
	

	//set_task(1.0, "informer", 183456, "", 0, "b")
	set_task(120.0, "Copyright", 484452, "", 0, "b")
	
	SyncHud = CreateHudSyncObj()
	SyncHud2 = CreateHudSyncObj()
	
	maxplayers = get_maxplayers()

        Mode()
	
	if(get_pcvar_num(enable_teams)>0 || get_pcvar_num(enable_ffa)>0)
		server_cmd("mp_friendlyfire 1")
	
	mp_friendlyfire = get_cvar_pointer("mp_friendlyfire");
	
	new mod[6];
	get_modname(mod,5);
	if(equal(mod,"czero"))
	{
		czero = 1;
		bot_quota = get_cvar_pointer("bot_quota");
	}
	
	gmsgScreenFade = get_user_msgid("ScreenFade");
	gmsgStatusIcon = get_user_msgid("StatusIcon");
	gmsgBlinkAcct = get_user_msgid("BlinkAcct");
	gmsgAmmoPickup = get_user_msgid("AmmoPickup");
	gmsgWeapPickup = get_user_msgid("WeapPickup");
	gmsgTextMsg = get_user_msgid("TextMsg");

	register_forward(FM_SetModel,"fw_setmodel",1);
	register_message(get_user_msgid("DeathMsg"),"msg_deathmsg");
	
	register_event("TextMsg", "event_round_restart", "a", "2=#Game_Commencing", "2=#Game_will_restart_in");
	register_event("HLTV", "event_new_round", "a", "1=0", "2=0");

	RegisterHam(Ham_Spawn,"player","ham_player_spawn",1);
	RegisterHam(Ham_Killed,"player","ham_player_killed",1);
	RegisterHam(Ham_Player_ResetMaxSpeed,"player","ham_player_resetmaxspeed",1);
	RegisterHam(Ham_Think,"grenade","ham_grenade_think",0);
	RegisterHam(Ham_Use, "player_weaponstrip", "ham_player_weaponstrip_use", 1);
	
	for(new i=0; i<sizeof GRENADE_NAMES; i++)
	{
		RegisterHam(Ham_Item_Deploy, GRENADE_NAMES[i], "ham_grenade_deploy", 1);
		RegisterHam(Ham_Item_Holster, GRENADE_NAMES[i], "ham_grenade_holster", 1);
		RegisterHam(Ham_Item_AddToPlayer, GRENADE_NAMES[i], "ham_grenade_addtoplayer", 1);
		RegisterHam(Ham_Item_AddDuplicate, GRENADE_NAMES[i], "ham_grenade_addduplicate", 1);
	}
		
	fnFwdPlayerChilled = CreateMultiForward("frostnades_player_chilled", ET_STOP, FP_CELL, FP_CELL);
	fnFwdPlayerFrozen  = CreateMultiForward("frostnades_player_frozen",  ET_STOP, FP_CELL, FP_CELL);
}

public cmdJoinClass( id )
{
    new arg[ 2 ]
    read_argv( 1, arg, charsmax( arg ) )
    
    set_task(1.0, "yes", id)
    
    return PLUGIN_CONTINUE
}  

public TraceAttack(victim, attacker, Float:damage, Float:direction[3], tracehandle, damagebits)
{
	if(get_pcvar_num(enable_teams)<1 || get_pcvar_num(enable_ffa)<1)
		return HAM_IGNORED
	if( victim != attacker && (1 <= attacker <= maxplayers) )
	{
		new vteam = fm_get_user_team(victim)
		if( vteam == fm_get_user_team(attacker) )
		{
			fm_set_user_team(victim, vteam == 1 ? 2 : 1)
			ExecuteHamB(Ham_TraceAttack, victim, attacker, damage, direction, tracehandle, damagebits)
			fm_set_user_team(victim, vteam)
			return HAM_SUPERCEDE
		}
	}
	return HAM_IGNORED
}

public TakeDamage(victim, idinflictor, attacker, Float:damage, damagebits)
{
	if(get_pcvar_num(enable_teams)<1 || get_pcvar_num(enable_ffa)<1)
		return HAM_IGNORED
	if( victim != attacker && (1 <= attacker <= maxplayers) )
	{
		new vteam = fm_get_user_team(victim)
		if( vteam == fm_get_user_team(attacker) )
		{
			fm_set_user_team(victim, vteam == 1 ? 2 : 1)
			ExecuteHamB(Ham_TakeDamage, victim, idinflictor, attacker, damage, damagebits)
			fm_set_user_team(victim, vteam)
			return HAM_SUPERCEDE
		}
	}
	return HAM_IGNORED
}

public Killed(victim, attacker, shouldgib)
{
	if(get_pcvar_num(enable_teams)<1 || get_pcvar_num(enable_ffa)<1)
		return HAM_IGNORED
	if( victim != attacker && (1 <= attacker <= maxplayers) )
	{
		new vteam = fm_get_user_team(victim)
		if( vteam == fm_get_user_team(attacker) )
		{
			fm_set_user_team(victim, vteam == 1 ? 2 : 1)
			ExecuteHamB(Ham_Killed, victim, attacker, shouldgib)
			fm_set_user_team(victim, vteam)
			return HAM_SUPERCEDE
		}
	}
	return HAM_IGNORED
}

public Copyright(id){
	ChatColor(id, "!gSurf Manager v 1.0 created by Dosyk.")
}

public plugin_cfg()
{
    //Open our vault and have g_Vault store the handle.
    g_Vault = nvault_open( "surf" );

    //Make the plugin error if vault did not successfully open
    if ( g_Vault == INVALID_HANDLE )
        set_fail_state( "Error opening nVault" );

    //This will remove all entries in the vault that are 5+ (or cvar+) days old at server-start
    //or map-change
    //nvault_prune( g_Vault , 0 , get_systime() - ( 86400 * get_pcvar_num( g_pExpireDays ) ) );
}

public plugin_end()
{
	//Close the vault when the plugin ends (map change\server shutdown\restart)
	nvault_close( g_Vault );
	DestroyForward(fnFwdPlayerChilled);
	DestroyForward(fnFwdPlayerFrozen);
}

public plugin_precache( ) { 

	precache_model("models/player/team_1/team_1.mdl")
	precache_model("models/player/team_2/team_2.mdl")
	precache_model("models/player/team_3/team_3.mdl")
	precache_model("models/player/team_4/team_4.mdl")
	precache_model("models/player/team_5/team_5.mdl")
	
	precache_sound("team_winner2/01.wav")
	precache_sound("team_winner2/02.wav")
	precache_sound("team_winner2/03.wav")
	precache_sound("team_winner2/04.wav")
	precache_sound("team_winner2/countdown2.wav")

	sprite_fire = precache_model(SPRITE_MODEL)
	precache_sound(JETPACK_GOTSOUND)
	precache_model(JETPACK_PMODEL)
	
	precache_model(VIEW_FROST) 


	new iEntity3 = find_ent_by_class( -1, "func_water" ) // This fixes a water wave height bug.
	DispatchKeyValue( iEntity3, "WaveHeight", "0.0" ) //

	precache_model(MODEL_FROZEN);
	glassGibs = precache_model(MODEL_GLASSGIBS);

	precache_sound(SOUND_EXPLODE); // grenade explodes
	precache_sound(SOUND_FROZEN); // player is frozen
	precache_sound(SOUND_UNFROZEN); // frozen wears off
	precache_sound(SOUND_CHILLED); // player is chilled
	precache_sound(SOUND_PICKUP); // player buys frostnade

	trailSpr = precache_model(SPRITE_TRAIL);
	smokeSpr = precache_model(SPRITE_SMOKE);
	exploSpr = precache_model(SPRITE_EXPLO);
} 

public set_client_kv(id, const info[], const key[])
{
if(equal(key, "model"))
	return FMRES_SUPERCEDE
	
return FMRES_IGNORED
}

public player_damage(victim, ent, attacker, Float:damage, bits){
	if(!is_user_connected(attacker))
	return HAM_IGNORED
	
	if(cs_get_user_buyzone(victim) && cs_get_user_buyzone(attacker)){
		engclient_cmd(attacker, "weapon_knife")
		client_print(attacker, print_center, "Убивать в оружейке запрещенно!")
		return HAM_SUPERCEDE
		}

	if(arcade==1 && victim != attacker)
		return HAM_SUPERCEDE

	if(arcade==0 && teamka[victim] == teamka[attacker] && teamka[victim]!=5)
		return HAM_SUPERCEDE

	if(get_pcvar_num(enable_teams)<1 || get_pcvar_num(enable_ffa)<1)
		return HAM_IGNORED
	if( victim != attacker && (1 <= attacker <= maxplayers) )
	{
		new vteam = fm_get_user_team(victim)
		if( vteam == fm_get_user_team(attacker) )
		{
			fm_set_user_team(victim, vteam == 1 ? 2 : 1)
			ExecuteHamB(Ham_TakeDamage, victim, ent, attacker, damage, bits)
			fm_set_user_team(victim, vteam)
			return HAM_SUPERCEDE
		}
	}
	return HAM_IGNORED
}

public FwdPlayerBloodColorPre(id)
{
    if(arcade==1)
    {
        SetHamReturnInteger(-1)
        
        return HAM_SUPERCEDE
    }
    
    return HAM_IGNORED
}

public check(){
new Players[32] 
new playerCount
get_players(Players, playerCount) 

if(playerCount>15) // - под 20 слотов!
	server_cmd("amx_force_round_nonstop off")
else if(playerCount<12)
	server_cmd("amx_force_round_nonstop on")
}

public Mode(){
	new line, text[64], txtlen
	while((line = read_file("addons/amxmodx/configs/arcades.ini",line,text,63,txtlen)) != 0)
	{     
	if (containi(MapName, text[0]) !=  -1){
		server_cmd("sv_checkpoint 1")
		pause("ac","stuck.amxx")
		arcade = 1
		return
		}
        arcade = 0
        }
}

public scout(id){
	if(!is_user_connected(id) || !is_user_alive(id))
		return
	if(arcade==1){
		strip_user_weapons(id)
		give_item(id, "weapon_knife")
		cs_set_weapon_ammo(give_item(id, "weapon_scout"), -1)
		return
		}
	else
		client_print(id, print_center, "%L",id,"NO_SCOUT")
}

public show_timer(id)
{
    if(task_exists(id))   // Проверка на выполнения Task, если выполняется Task
    {
        remove_task(id)   // Останавливаем его (Task)
    }
      
    szTime[id] = 3   // szTime[id] ранее наш зарегистрированный массив, 15 время в секундах
    // Запускаем таймер
    set_task(1.0, "show_second_timer", id, _, _, "b")   // Время через которое будет -1 сек от нашего таймера
}
   
public show_second_timer(id)
{
    // Если время больше или равна 1 то показываем сообщение (таймер исчезнет после 1 последней секунды, если 0, будет показана 0 секунда)
    if(szTime[id] >= 1)
    {
        szTime[id] --   // Отнимаем время от нашего таймера
        set_hudmessage(255, 0, 0, -1.0, -1.0, 0, 6.0, 1.0)   // Устанавливаем цвет, координаты, эффекты сообщения
        show_hudmessage(id, "%L",id,"GOD",szTime[id])   //сообщение
          
    }
    else   // Если время истекло 
    { 
        remove_task(id)   // Останавливаем (Task)
        //ExecuteHamB(Ham_CS_RoundRespawn, id)   // Воскрешаем игрока
    }
}


//***Магаз***//

public shop_menu(id) 
{
	new szText[ 555 char ];

	format( szText, charsmax( szText ), "%L", id, "SHOP", score[id] );
	new menu = menu_create(szText, "shop_handler")

	if(is_user_alive(id) && g_HasJetpack[id] == 0 && score[id]>19){	
	        formatex( szText, charsmax( szText ), "\w%L", id, "MENU_JET", get_pcvar_num(price_jet))
        	menu_additem( menu, szText, "1", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_JET", get_pcvar_num(price_jet))
        	menu_additem( menu, szText, "1", 0 )
        	}

	if(is_user_alive(id) && shop_hp[id] == 0 && score[id]>4){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_HP", get_pcvar_num(hp_amount), get_pcvar_num(price_hp))
        	menu_additem( menu, szText, "2", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_HP", get_pcvar_num(hp_amount), get_pcvar_num(price_hp))
        	menu_additem( menu, szText, "2", 0 )
        	}

	if(is_user_alive(id) && shop_glock[id]==0 && score[id]>14 && arcade==0){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_GLOCK", get_pcvar_num(price_glock))
        	menu_additem( menu, szText, "7", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_GLOCK", get_pcvar_num(price_glock))
        	menu_additem( menu, szText, "7", 0 )
        	}

	if(is_user_alive(id) && shop_mgun[id]==0 && score[id]>24 && arcade==0){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_MINIGUN", get_pcvar_num(price_minigun))
        	menu_additem( menu, szText, "3", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_MINIGUN", get_pcvar_num(price_minigun))
        	menu_additem( menu, szText, "3", 0 )
        	}

	if(is_user_alive(id) && hasFrostNade[id]==0 && score[id]>9 && arcade==0){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_FROST", get_pcvar_num(price_frost))
        	menu_additem( menu, szText, "4", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_FROST", get_pcvar_num(price_frost))
        	menu_additem( menu, szText, "4", 0 )
        	}

	if(is_user_alive(id) && speed[id]==0 && score[id]>6){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_SPEED", get_pcvar_num(price_speed))
        	menu_additem( menu, szText, "5", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_SPEED", get_pcvar_num(price_speed))
        	menu_additem( menu, szText, "5", 0 )
        	}

	if(is_user_alive(id) && gravity[id]==0 && score[id]>6){
		formatex( szText, charsmax( szText ), "\w%L", id, "MENU_GRAVITY", get_pcvar_num(price_gravity))
        	menu_additem( menu, szText, "6", 0 )
        	}
	else{
		formatex( szText, charsmax( szText ), "\d%L", id, "MENU_GRAVITY", get_pcvar_num(price_gravity))
        	menu_additem( menu, szText, "6", 0 )
        	}

	menu_setprop(menu, MPROP_EXITNAME, "Exit")
	menu_setprop(menu, MPROP_EXIT,MEXIT_ALL)
	
	if(get_pcvar_num(shop_enable)<1){
		ChatColor(id,"%s %L",PREFIX,LANG_PLAYER,"SHOP_OFF")
		return
		}
	
	menu_display(id,menu,0)
}

public shop_handler(id, menu, item) 
{	     
	if(item == MENU_EXIT) 
	{
		menu_destroy(menu)
	        return
	}

	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	     
	new key = str_to_num(data)
	
	     
	switch(key) 
	{
	        case 1:{
	            	if(g_HasJetpack[id]==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_jet))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{	
		            	_give_Jetpack(id)
		            	score[id]=score[id]-get_pcvar_num(price_jet)
		            	cmdSaveScore(id)
		            	}	
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 2:{
	            	if(shop_hp[id]==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_hp))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{
		            	set_user_health(id, get_pcvar_num(hp_amount))
		            	shop_hp[id]=1
		            	score[id]=score[id]-get_pcvar_num(price_hp)
		            	client_cmd(id, "spk %s", JETPACK_GOTSOUND)
		            	cmdSaveScore(id)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_HP", get_pcvar_num(hp_amount))
		            	}
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 3:{
	            	if(shop_mgun[id]==1 || arcade==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_minigun))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{				
				shop_mgun[id]=1
		            	score[id]=score[id]-get_pcvar_num(price_minigun)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_MINIGUN")
		            	cmdSaveScore(id)
		            	if(ok[id]==0)
		            		return
		            	give_item(id, "weapon_m249")
		            	cs_set_user_bpammo(id, CSW_M249 , 200)
		            	}
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 4:{
	            	if(hasFrostNade[id]!=0 || arcade==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_frost))
		            	client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{
		            	buy_frostnade(id)
		            	score[id]=score[id]-get_pcvar_num(price_frost)
		            	cmdSaveScore(id)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_FROST")
		            	}			
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 5:{
	            	if(speed[id]==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_speed))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{
		            	set_user_maxspeed(id, 400.0)
		            	score[id]=score[id]-get_pcvar_num(price_speed)
		            	speed[id] = 1
		            	cmdSaveScore(id)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_SPEED")
				}
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 6:{
	            	if(gravity[id]==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_gravity))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{
		            	set_user_gravity(id, 0.7)
		            	score[id]=score[id]-get_pcvar_num(price_gravity)
		            	gravity[id] = 1
		            	cmdSaveScore(id)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_GRAVITY")
				}
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	        case 7:{
	            	if(shop_glock[id]==1 || arcade==1){
	            		client_cmd(id,"shop")
	            		return
	            		}
	            	if(is_user_alive(id)){
	            	if(score[id]<get_pcvar_num(price_glock))
				client_print(id, print_center, "%L",id,"NOT_ENOUGH")
			else{
		            	shop_glock[id] = 1
		            	score[id]=score[id]-get_pcvar_num(price_glock)
		            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"BUY_GLOCK")
		            	cmdSaveScore(id)
		            	if(ok[id]==0)
		            		return
		            	give_item(id, "weapon_glock18")
		            	cs_set_user_bpammo(id, CSW_GLOCK18 , 50)
				}
			}
			else{
	            		client_print(id, print_center, "%L",id,"ONLY_ALIVE")
                        	client_cmd(id,"shop")
                        }
	        }
	}
}

//***Магаз***//

public nahui(id){
	if(!is_user_connected(id) || !is_user_alive(id))
		return
	strip_user_weapons(id)
	return
}

public DeathMsg(){
   new iKiller, iHeadShot, iVictim, sWeapon[6]

   iVictim = read_data(2) 

   if(arcade==1){
   	cs_set_user_deaths(iVictim,-1)
   	return
   	}

   iKiller = read_data(1) 
   iHeadShot = read_data(3)
   read_data(4, sWeapon, 5) 
       
   if(iKiller == iVictim)
   	return

   if(!iKiller && equal(sWeapon, "world", 5))
	return	

   if(!iKiller && equal(sWeapon, "trigger_hurt", 12))
	return
	
   new player = get_user_userid(iKiller)
   if(player==0)
   	return
   
   if(iHeadShot){
   	score[iKiller] += 2
   	ChatColor(iKiller, "%s %L", PREFIX, LANG_PLAYER, "HEADSHOT", score[iKiller])
   	cmdSaveScore(iKiller)
   	if(teamka[iKiller]==1){
   		++red_score
   		return
   		}

   	if(teamka[iKiller]==2){
   		++blue_score
   		return
   		}

	if(teamka[iKiller]==3){
   		++green_score
   		return
   		}

	if(teamka[iKiller]==4){
   		++black_score
   		return
   		}
   	return
   	}
   else{
   	score[iKiller] += 1
   	ChatColor(iKiller, "%s %L", PREFIX, LANG_PLAYER, "KILL", score[iKiller])
   	cmdSaveScore(iKiller)
   	if(teamka[iKiller]==1)
   		++red_score

   	if(teamka[iKiller]==2)
   		++blue_score

	if(teamka[iKiller]==3)
   		++green_score

	if(teamka[iKiller]==4)
   		++black_score

   	return
   	}

   return
}

public cmdSaveScore(id)
{
    new szData[16];    //Data key holding kills and deaths in this format: "15 2"
    new szKey[40];    //Key to store data: "STEAM_0:0:1234SCORE"

    formatex( szKey , charsmax( szKey ) , "%sSCORE" , g_szAuthID[id] );
    formatex( szData , charsmax( szData ) , "%d         0" , score[id] );

    nvault_set( g_Vault , szKey , szData );
}

public cmdGetScore(id)
{
    new szData[16];
    new szKey[40];

    formatex( szKey , charsmax( szKey ) , "%sSCORE" , g_szAuthID[id] );

    if ( nvault_get( g_Vault , szKey , szData , charsmax( szData ) ) )
    {
        new iSpacePos = contain( szData , " " );
        
        if ( iSpacePos > -1 )
        {    
            new szKills[8];
            
            formatex( szKills , charsmax( szKills ) , "%s" , szData );

            score[id] = str_to_num( szKills )

        }
    }
    else
	return
}  

public Player_Death(id){
	g_HasJetpack[id] = 0
	_removeJetpackEnt(id)
	hp[id] = 0  
	shop_hp[id] = 0
	shop_mgun[id] = 0
	shop_glock[id] = 0
	set_task(1.0,"yes",id)   
}

public yes(id){
	if(!is_user_connected(id) || is_user_alive(id) || get_pcvar_num(enable_dm)<1)
		return
	if(fm_get_user_team(id) == 3 || fm_get_user_team(id) != 3 && fm_get_user_team(id) != 2 && fm_get_user_team(id) != 1)
		return
	ExecuteHamB(Ham_Spawn, id)
	//dllfunc(DLLFunc_Spawn,id)
	//set_task(3.0,"yes",id)
	//set_task(7.0,"yes",id)
	return
}

public go(id){
	if(!is_user_connected(id) || !is_user_alive(id))
		return

	TouchWeapons[id]=1
	show_timer(id)
	set_user_godmode(id,1)
	set_user_rendering(id, kRenderFxGlowShell, 10, 255, 10, kRenderNormal,16)
	set_task(3.0,"give",id)


	if(teamka[id]==0 && arcade==0 && get_pcvar_num(enable_teams)>0){
		team_menu(id)
		return
		}
	shop_menu(id)
	return
}

public give(id){
	if(!is_user_connected(id) || !is_user_alive(id))
		return
		
	set_user_godmode(id,0)
	set_user_rendering(id,_,0,0,0,_,0)
	TouchWeapons[id]=0

	give_item(id,"weapon_knife")
	
	if(shop_mgun[id]==1){
		give_item(id, "weapon_m249")
		cs_set_user_bpammo(id, CSW_M249 , 200)
	}
	if(shop_glock[id]==1){
		give_item(id, "weapon_glock18")
		cs_set_user_bpammo(id, CSW_GLOCK18 , 50)
	}

	ok[id] = 1

	return
}

//Teams

public team_menu(id) 
{
	new szText[ 999 char ]

	if(teamka[id]==1)
		format( szText, charsmax( szText ), "%L %L", id, "TEAM_MENU_TXT", id, "RED")
	if(teamka[id]==2)
		format( szText, charsmax( szText ), "%L %L", id, "TEAM_MENU_TXT", id, "BLUE")
	if(teamka[id]==3)
		format( szText, charsmax( szText ), "%L %L", id, "TEAM_MENU_TXT", id, "GREEN")
	if(teamka[id]==4)
		format( szText, charsmax( szText ), "%L %L", id, "TEAM_MENU_TXT", id, "BLACK")
	if(teamka[id]==5 || teamka[id]==0)
		format( szText, charsmax( szText ), "%L %L", id, "TEAM_MENU_TXT", id, "LONER")

	new menu = menu_create(szText, "menu_handler_now")

        formatex( szText, charsmax( szText ), "%L", id, "RED")
        menu_additem( menu, szText, "1", 0 )
        formatex( szText, charsmax( szText ), "%L", id, "BLUE")
        menu_additem( menu, szText, "2", 0 )
        formatex( szText, charsmax( szText ), "%L", id, "GREEN")
        menu_additem( menu, szText, "3", 0 )
        formatex( szText, charsmax( szText ), "%L", id, "BLACK")
        menu_additem( menu, szText, "4", 0 )
        formatex( szText, charsmax( szText ), "%L", id, "LONER")
        menu_additem( menu, szText, "5", 0 )
        
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER)

	if(allowed_now[id]!=1){
		ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"WAIT_TEAM")
        	return
        	}
        if(arcade==1){
		ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_ARCADE")
        	return
        	}

	menu_display(id,menu,0)

}

public ebaw(tid){
	new id = tid - 4231
	allowed_now[id] = 1
}

public pizdec(id){
	set_task(300.0, "ebaw", id + 4231)
	if(teamka[id]==1)
		--t_red
	if(teamka[id]==2)
		--t_blue
	if(teamka[id]==3)
		--t_green
	if(teamka[id]==4)
		--t_black
}
	
	 
public menu_handler_now(id, menu, item) 
{
	if(item == MENU_EXIT) 
	{
		menu_destroy(menu)
	        return PLUGIN_HANDLED
	}
	     
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	     
	new key = str_to_num(data)
	     
	switch(key) 
	{
		case 1:{
			if(t_red>7){
				ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_FULL")
				team_menu(id) 
				return PLUGIN_CONTINUE
				}
			pizdec(id)
			teamka[id]=1
			set_user_info(id, "model", "team_1")
			allowed_now[id] = 0
			ChatColor(id, "%s %L%L",PREFIX,LANG_PLAYER,"CHOSE",LANG_PLAYER,"RED")
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_INFO")
			get_user_name(id,name,31)
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"NEW_RED", name)
			++t_red
			return PLUGIN_CONTINUE
	        }
		case 2:{
			if(t_blue>7){
				ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_FULL")
				team_menu(id) 
				return PLUGIN_CONTINUE
				}
			pizdec(id)
			teamka[id]=2
			set_user_info(id, "model", "team_2")
			allowed_now[id] = 0
			ChatColor(id, "%s %L%L",PREFIX,LANG_PLAYER,"CHOSE",LANG_PLAYER,"BLUE")
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_INFO")
			get_user_name(id,name,31)
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"NEW_BLUE", name)
			++t_blue
			return PLUGIN_CONTINUE
	        }
		case 3:{
			if(t_green>7){
				ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_FULL")
				team_menu(id) 
				return PLUGIN_CONTINUE
				}
			pizdec(id)
			teamka[id]=3
			set_user_info(id, "model", "team_3")
			allowed_now[id] = 0
			ChatColor(id, "%s %L%L",PREFIX,LANG_PLAYER,"CHOSE",LANG_PLAYER,"GREEN")
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_INFO")
			get_user_name(id,name,31)
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"NEW_GREEN", name)
			++t_green
			return PLUGIN_CONTINUE
	        }
		case 4:{
			if(t_black>7){
				ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_FULL")
				team_menu(id) 
				return PLUGIN_CONTINUE
				}
			pizdec(id)
			teamka[id]=4
			set_user_info(id, "model", "team_4")
			allowed_now[id] = 0
			ChatColor(id, "%s %L%L",PREFIX,LANG_PLAYER,"CHOSE",LANG_PLAYER,"BLACK")
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_INFO")
			get_user_name(id,name,31)
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"NEW_BLACK", name)
			++t_black
			return PLUGIN_CONTINUE
	        }
		case 5:{
			pizdec(id)
			teamka[id]=5
			set_user_info(id, "model", "team_5")
			ChatColor(id, "%s %L%L",PREFIX,LANG_PLAYER,"CHOSE",LANG_PLAYER,"LONER")
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"TEAM_INFO")
			get_user_name(id,name,31)
			ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"NEW_LONER", name)
			return PLUGIN_CONTINUE
	        }
	}
	return PLUGIN_CONTINUE
}

public informer(){
	if(arcade==1 || get_pcvar_num(enable_teams)<1)
		return
	new i
	for(i=1; i<=maxplayers; i++)
	{
	set_hudmessage(50, 255, 50, 0.01, 0.18, 0, 0.0, FREQ, 0.01, 0.0)
	ShowSyncHudMsg(i, SyncHud2, "%L", i, "TEAM_INFORMER", red_score, blue_score, green_score, black_score)
	}
}

//Teams

public TouchWeapon(weapon, id)
{
	if(!is_user_connected(id))
	{
		return HAM_IGNORED
	}
	if(TouchWeapons[id]==1)
	{
		return HAM_SUPERCEDE
	}
	return HAM_IGNORED
}

public eng(id){
	translit[id] = 0
}

public Think(ent)
{
	if(ent == TaskEnt) 
	{
		InformerTask()
		informer()
		set_pev(ent, pev_nextthink,  get_gametime() + FREQ)
	}
}

public client_putinserver(id){
	++igrok
	translit[id] = 1
	g_HasJetpack[id] = 0
	speed[id] = 0
	team[id] = 0
	ok[id] = 0
	shop_hp[id] = 0
	shop_mgun[id] = 0
	shop_glock[id] = 0
	hp[id] = 0
	gravity[id] = 0
	teamka[id] = 0
	allowed_now[id] = 1
	plrInfo[id] = showinfromer > 0 ? true : false
	cmdGetScore(id)
	isChilled[id] = 0;
	isFrozen[id] = 0;
	frostKilled[id] = 0;
	novaDisplay[id] = 0;
	hasFrostNade[id] = 0;
		
	if(czero && !czBotHams && is_user_bot(id) && get_pcvar_num(bot_quota) > 0)
		set_task(0.1,"czbot_hook_ham",id);
}

public toogleInfo(id)
{
	plrInfo[id] = plrInfo[id] ? false : true
	return PLUGIN_HANDLED
}

InformerTask()
{
	static i, target
	static Float:velocity[3]
	static Float:speed
	
	for(i=1; i<=maxplayers; i++)
	{
		if(!is_user_connected(i)) continue
		if(!plrInfo[i]) continue
		
		target = pev(i, pev_iuser1) == 4 ? pev(i, pev_iuser2) : i
		pev(target, pev_velocity, velocity)

		speed = vector_length(velocity)
		
		set_hudmessage(50, 255, 50, -1.0, 0.7, 1, 0.0, FREQ, 0.01, 0.0)
				
		new Len, Message[512]
		Len = format(Message, 511, "%3.2f", speed)		
		if(arcade==0 && get_pcvar_num(pcv_team)>0 && get_pcvar_num(enable_teams)>0){
		switch( teamka[i] ) {
			case 1:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "RED")
			case 2:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "BLUE")
			case 3:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "GREEN")
			case 4:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "BLACK")
			case 5:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "LONER")
			case 0:
				Len += format(Message[Len], 511 - Len, "^n%L: %L", i, "TEAM", i, "LONER")
			}
		}
		if(get_pcvar_num(pcv_hp)>0)
			Len += format(Message[Len], 511 - Len, "^n%L: %d", i, "HEALTH", get_user_health(i))
		if(get_pcvar_num(pcv_score)>0)
			Len += format(Message[Len], 511 - Len, "^n%L", i, "SCORE", score[i])
		if(get_pcvar_num(pcv_players)>0)
			Len += format(Message[Len], 511 - Len, "^n%L: %d|%d", i, "PLAYERS", igrok, maxplayers)
		
		ShowSyncHudMsg(i, SyncHud, "%s", Message)
	}
}

public client_authorized(id)
{
get_user_authid( id , g_szAuthID[id] , charsmax( g_szAuthID[] ) )
client_cmd(id, "cl_filterstuffcmd 1")
client_cmd(id, "cl_forwardspeed 900")
}



public rules(id) 
{
	new RulesTxt[ 777 char ];
	formatex( RulesTxt, charsmax( RulesTxt ), "%L", id, "SURF_RULES")
	
	new menu = menu_create(RulesTxt, "rules_handler")

	formatex( RulesTxt, charsmax( RulesTxt ), "%L", id, "YES")
	menu_additem( menu, RulesTxt, "1", 0 )

	formatex( RulesTxt, charsmax( RulesTxt ), "%L", id, "NO")
	menu_additem( menu, RulesTxt, "2", 0 )

	menu_display(id,menu,0)
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER)
}

public rules_handler(id, menu, item) 
{	     
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	     
	new key = str_to_num(data)
	     
	switch(key) 
	{
		case 1:{
	            	if(!is_user_connected(id))
				return
	            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"GOOD")
	        }
	        case 2:{
	            	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"OHWELL")
	        }
	}
}

public _give_Jetpack(id)
{
	if(!is_user_alive(id) || g_HasJetpack[id] == 1)
		return
	
	g_HasJetpack[id] = 1
	client_cmd(id, "spk %s", JETPACK_GOTSOUND)
	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"JET")
	
	if(g_JetpackEnt[id] < 1)
	{
		g_JetpackEnt[id] = create_entity("info_target")
		if(is_valid_ent(g_JetpackEnt[id]))
		{
			entity_set_model(g_JetpackEnt[id], JETPACK_PMODEL)
			entity_set_int(g_JetpackEnt[id], EV_INT_movetype, MOVETYPE_FOLLOW)
			entity_set_edict(g_JetpackEnt[id], EV_ENT_aiment, id)
		}
	}
}

public _removeJetpackEnt(id)
{
	if(g_JetpackEnt[id] > 0)
		remove_entity(g_JetpackEnt[id])
	g_JetpackEnt[id] = 0
}

public client_PreThink(id)
{
	if(!is_user_alive(id) || !g_HasJetpack[id])
		return PLUGIN_CONTINUE
		
	if(get_user_speed(id) < 400)
		return PLUGIN_CONTINUE	
		
	new Button = get_user_button(id)
	if(Button & IN_MOVELEFT || Button & IN_MOVERIGHT)
	{		
		_jetEffect(id)	
		_jetThrust(id)
	}
	return PLUGIN_CONTINUE
}

public _jetThrust(id)
{	
	new Float:fVelocity[3]
	entity_get_vector(id, EV_VEC_velocity, fVelocity)

	new Float:fAngle[3]
	entity_get_vector(id, EV_VEC_angles, fAngle)
	engfunc(EngFunc_MakeVectors, fAngle)
				
	new Float:fForward[3]
	get_global_vector(GL_v_forward, fForward)
				
	fVelocity[0] += fForward[0] * 10
	fVelocity[1] += fForward[1] * 10
			
	if(get_user_speed(id) < 1200)
		entity_set_vector(id, EV_VEC_velocity, fVelocity)
		
	return PLUGIN_CONTINUE
}

public _jetEffect(id)
{	
	new iOrigin[3]
	get_user_origin(id, iOrigin, 0)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)
	write_coord(iOrigin[0])
	write_coord(iOrigin[1])
	write_coord(iOrigin[2])
	write_short(sprite_fire)
	write_byte(10)
	write_byte(115)
	message_end()
	
	entity_set_int(id , EV_INT_gaitsequence , 8)
}

stock get_user_speed(id)
{
	new Float:fVelocity[3]
	entity_get_vector(id, EV_VEC_velocity, fVelocity)
	
	new iVelocity[3]
	FVecIVec(fVelocity, iVelocity)
	
	new iVelocity0 = iVelocity[0] * iVelocity[0]
	new iVelocity1 = iVelocity[1] * iVelocity[1]
	
	return sqroot(iVelocity0 + iVelocity1)
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    new msg[191]
    vformat(msg, 190, input, 3)
    
    replace_all(msg, 190, "!g", "^4") 
    replace_all(msg, 190, "!y", "^1") 
    replace_all(msg, 190, "!team", "^3") 
    replace_all(msg, 190, "!team2", "^0")
    
    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
} 

public client_disconnect(id)
{
	--igrok
	if(teamka[id]==1)
		--t_red
	if(teamka[id]==2)
		--t_blue
	if(teamka[id]==3)
		--t_green
	if(teamka[id]==4)
		--t_black
	
	if(isChilled[id]) task_remove_chill(TASK_REMOVE_CHILL+id);
	if(isFrozen[id]) task_remove_freeze(TASK_REMOVE_FREEZE+id);
}

// registering a ham hook for "player" won't register it for CZ bots,
// for some reason. so we have to register it by entity. 
public czbot_hook_ham(id)
{
	if(!czBotHams && is_user_connected(id) && is_user_bot(id) && get_pcvar_num(bot_quota) > 0)
	{
		RegisterHamFromEntity(Ham_Spawn,id,"ham_player_spawn",1);
		RegisterHamFromEntity(Ham_Killed,id,"ham_player_killed",1);
		RegisterHamFromEntity(Ham_Player_ResetMaxSpeed,id,"ham_player_resetmaxspeed",1);
		czBotHams = 1;
	}
}

// intercept server log messages to replace grenade kills with frostgrenade kills
public plugin_log()
{
	static arg[512];
	
	if(read_logargc() >= 5)
	{
		read_logargv(1, arg, 7); // "killed"
		
		if(equal(arg, "killed"))
		{
			read_logargv(2, arg, 127); // info of player that was killed
			
			// get ID of player that was killed
			new dummy[1], killedUserId;
			parse_loguser(arg, dummy, 0, killedUserId);
			new killedId = find_player("k", killedUserId);
			
			if(killedId && frostKilled[killedId])
			{	
				// override with frostgrenade message
				read_logdata(arg, 511);
				replace(arg, 511, "with ^"grenade^"", "with ^"frostgrenade^"");				
				log_message("%s", arg);

				return PLUGIN_HANDLED;
			}
		}
	}
	
	return PLUGIN_CONTINUE;
}

/****************************************
* PRIMARY FUNCTIONS AND SUCH
****************************************/

public buy_frostnade(id)
{
	if(!get_pcvar_num(pcv_enabled) || get_pcvar_num(pcv_override))
		return PLUGIN_CONTINUE;

	if(!is_user_alive(id)) return PLUGIN_HANDLED;

	if(get_pcvar_num(pcv_buyzone) && !cs_get_user_buyzone(id))
	{
		// #Cstrike_NotInBuyZone won't work for some reason
		client_print(id,print_center,"You are not in a buy zone.");

		return PLUGIN_HANDLED;
	}

	if(!(get_pcvar_num(pcv_teams) & _:fm_get_user_team(id)) && is_user_connected(id))
	{
		// have to do it this way to format
		message_begin(MSG_ONE,gmsgTextMsg,_,id);
		write_byte(print_center);
		write_string("#Alias_Not_Avail");
		write_string("Frost Grenade");
		message_end();

		return PLUGIN_HANDLED;
	}

	if(hasFrostNade[id])
	{
		client_print(id,print_center,"#Cstrike_Already_Own_Weapon");
		return PLUGIN_HANDLED;
	}
	
	new limit = get_pcvar_num(pcv_limit);
	if(limit && nadesBought[id] >= limit)
	{
		client_print(id,print_center,"#Cstrike_TitlesTXT_Cannot_Carry_Anymore");
		return PLUGIN_HANDLED;
	}
	
	//new money = cs_get_user_money(id), price = get_pcvar_num(pcv_price);

	// need more vespene gas
	if(score[id] < 10 && is_user_connected(id))
	{
		client_print(id,print_center,"#Cstrike_TitlesTXT_Not_Enough_Money");
		
		message_begin(MSG_ONE_UNRELIABLE,gmsgBlinkAcct,_,id);
		write_byte(2);
		message_end();

		return PLUGIN_HANDLED;
	}
	
	// try to use smokegrenade, then flashbang, then hegrenade
	new wpnid = CSW_SMOKEGRENADE, ammoid = AMMO_SMOKEGRENADE, wpnName[20] = "weapon_smokegrenade", type = get_pcvar_num(pcv_nadetypes);
	if(!(type & NT_SMOKEGRENADE))
	{
		if(type & NT_FLASHBANG)
		{
			wpnid = CSW_FLASHBANG;
			ammoid = AMMO_FLASHBANG;
			wpnName = "weapon_flashbang";
		}
		else if(type & NT_HEGRENADE)
		{
			wpnid = CSW_HEGRENADE;
			ammoid = AMMO_HEGRENADE;
			wpnName = "weapon_hegrenade";
		}
	}
	hasFrostNade[id] = wpnid;
	nadesBought[id]++;
	//cs_set_user_money(id,money - price);

	new ammo = cs_get_user_bpammo(id,wpnid);

	// give him one
	if(!ammo) give_item(id,wpnName);
	else
	{
		cs_set_user_bpammo(id,wpnid,ammo+1);
		
		// just so the player can see what kind it is on his HUD
		
		if(!is_user_connected(id))
		return PLUGIN_HANDLED;

		message_begin(MSG_ONE,gmsgAmmoPickup,_,id);
		write_byte(ammoid);
		write_byte(ammo+1);
		message_end();

		message_begin(MSG_ONE,gmsgWeapPickup,_,id);
		write_byte(wpnid);
		message_end();
		
		// won't play via cs_set_user_bpammo
		engfunc(EngFunc_EmitSound,id,CHAN_ITEM,SOUND_PICKUP,VOL_NORM,ATTN_NORM,0,PITCH_NORM);
		
		// for icon management
		grenade_added(id, wpnid);
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

// entity is given a model (used to detect for thrown grenades)
public fw_setmodel(ent,model[])
{
	if(!get_pcvar_num(pcv_enabled)) return FMRES_IGNORED;

	new owner = pev(ent,pev_owner);
	if(!is_user_connected(owner)) return FMRES_IGNORED;
	
	// this isn't going to explode
	new Float:dmgtime;
	pev(ent,pev_dmgtime,dmgtime);
	if(dmgtime == 0.0) return FMRES_IGNORED;
	
	new type, csw;
	if(model[7] == 'w' && model[8] == '_')
	{
		switch(model[9])
		{
			case 'h': { type = NT_HEGRENADE; csw = CSW_HEGRENADE; }
			case 'f': { type = NT_FLASHBANG; csw = CSW_FLASHBANG; }
			case 's': { type = NT_SMOKEGRENADE; csw = CSW_SMOKEGRENADE; }
		}
	}
	if(!type) return FMRES_IGNORED;
	
	new team = _:fm_get_user_team(owner);

	// have a frostnade (override off) ;OR; override enabled, on valid team, using valid frostnade type
	if(hasFrostNade[owner] == csw || (get_pcvar_num(pcv_override)
			&& (get_pcvar_num(pcv_teams) & team) && (get_pcvar_num(pcv_nadetypes) & type)))
	{
		// not using override
		if(hasFrostNade[owner] == csw)
		{
			hasFrostNade[owner] = 0;
			if(get_pcvar_num(pcv_icon) == ICON_HASNADE)
			{
				show_icon(owner, STATUS_HIDE);
			}
		}

		set_pev(ent,pev_team,team);
		set_pev(ent,pev_bInDuck,1); // flag it as a frostnade

		new rgb[3], Float:rgbF[3];
		get_rgb_colors(team,rgb);
		IVecFVec(rgb, rgbF);
		
		// glowshell
		set_pev(ent,pev_rendermode,kRenderNormal);
		set_pev(ent,pev_renderfx,kRenderFxGlowShell);
		set_pev(ent,pev_rendercolor,rgbF);
		set_pev(ent,pev_renderamt,16.0);

		set_beamfollow(ent,10,10,rgb,100);
	}

	return FMRES_IGNORED;
}

// freeze a player in place whilst he's frozen
public fw_playerprethink(id)
{
	/*if(isChilled[id])
	{
		// remember rendering changes
		new fx = pev(id,pev_renderfx), Float:color[3], mode = pev(id,pev_rendermode), Float:amount;
		pev(id,pev_rendercolor,color);
		pev(id,pev_renderamt,amount);

		if(fx != kRenderFxGlowShell)
		{
			oldRenderFx[id] = fx;
			set_pev(id,pev_renderfx,kRenderFxGlowShell);
		}
		if(color[0] != glowColor[id][0] || color[1] != glowColor[id][1] || color[2] != glowColor[id][2])
		{
			oldRenderColor[id] = color;
			set_pev(id,pev_rendercolor,glowColor[id]);
		}
		if(mode != kRenderNormal)
		{
			oldRenderMode[id] = mode;
			set_pev(id,pev_rendermode,kRenderNormal);
		}
		if(amount != GLOW_AMOUNT)
		{
			oldRenderAmt[id] = amount;
			set_pev(id,pev_renderamt,GLOW_AMOUNT);
		}
	}*/

	if(isFrozen[id])
	{
		set_pev(id,pev_velocity,Float:{0.0,0.0,0.0}); // stop motion
		
		new Float:gravity;
		pev(id,pev_gravity,gravity);
		
		// remember any gravity changes
		if(gravity != 0.000000001 && gravity != 999999999.9)
			oldGravity[id] = gravity;

		// if are on the ground and about to jump, set the gravity too high to really do so
		if((pev(id,pev_button) & IN_JUMP) && !(pev(id,pev_oldbuttons) & IN_JUMP) && (pev(id,pev_flags) & FL_ONGROUND))
			set_pev(id,pev_gravity,999999999.9);

		// otherwise, set the gravity so low that they don't fall
		else set_pev(id,pev_gravity,0.000000001);
	}
	
	return FMRES_IGNORED;
}

// override grenade kill message with skull and crossbones
public msg_deathmsg(msg_id,msg_dest,msg_entity)
{
	new victim = get_msg_arg_int(2);
	if(!is_user_connected(victim) || !frostKilled[victim]) return PLUGIN_CONTINUE;

	static weapon[8];
	get_msg_arg_string(4,weapon,7);
	if(equal(weapon,"grenade")) set_msg_arg_string(4,"frostgrenade");

	//frostKilled[victim] = 0;
	return PLUGIN_CONTINUE;
}

// round is restarting (TAG: sv_restartround)
public event_round_restart()
{
	// just remember for event_new_round
	roundRestarting = true;
}

public ten(){
	new i 
	new players[32], plNum  
	get_players(players, plNum, "h")     
	for (i = 0; i < plNum; i++)	
		{ 
			client_cmd(players[i],"spk team_winner2/countdown2.wav")
		}
}

// start of a new round
public event_new_round()
{

	if(roundRestarting)
	{
		roundRestarting = false;
		
		// clear frost grenades from all players (for override mode)
		for(new i=1;i<=maxplayers;i++)
		{
			hasFrostNade[i] = 0;
		}
	}
}

// rezzed
public ham_player_spawn(id)
{
	ok[id] = 0
	go(id)
	nahui(id)

	switch( teamka[id] ) {
		case 1:
			set_user_info(id, "model", "team_1")
		case 2:
			set_user_info(id, "model", "team_2")
		case 3:
			set_user_info(id, "model", "team_3")
		case 4:
			set_user_info(id, "model", "team_4")
		case 5:
			set_user_info(id, "model", "team_5")
		case 0:
			set_user_info(id, "model", "team_5")
			}

	nadesBought[id] = 0;
	
	if(is_user_alive(id))
	{
		if(isChilled[id]) task_remove_chill(TASK_REMOVE_CHILL+id);
		if(isFrozen[id]) task_remove_freeze(TASK_REMOVE_FREEZE+id);
	}

	if(!is_user_alive(id) || !get_pcvar_num(pcv_enabled))
		return HAM_IGNORED

	if(get_pcvar_num(pcv_icon) == ICON_HASNADE)
	{
		new status = player_has_frostnade(id);
		show_icon(id, status);
	}
	
	return HAM_IGNORED;
}

// killed to death
public ham_player_killed(id)
{
	hasFrostNade[id] = 0;

	if(get_pcvar_num(pcv_enabled) && get_pcvar_num(pcv_icon) == ICON_HASNADE)
	{
		show_icon(id, STATUS_HIDE);
	}

	if(isChilled[id]) task_remove_chill(TASK_REMOVE_CHILL+id);
	if(isFrozen[id]) task_remove_freeze(TASK_REMOVE_FREEZE+id);
	
	return HAM_IGNORED;
}

// movement speed is changed
public ham_player_resetmaxspeed(id)
{
	new weaponID = read_data(2) 

	if(get_pcvar_num(pcv_enabled))
	{
		set_user_chillfreeze_speed(id);
	}
	
	if(speed[id]==1)
		set_user_maxspeed(id, 400.0)
	
	if(weaponID == CSW_SMOKEGRENADE && hasFrostNade[id] != 0)	
		set_pev(id, pev_viewmodel2, VIEW_FROST)

	return HAM_IGNORED;
}

// grenade is ticking away
public ham_grenade_think(ent)
{
	// not a frostnade
	if(!pev_valid(ent) || !pev(ent,pev_bInDuck)) return HAM_IGNORED;
	
	new Float:dmgtime;
	pev(ent,pev_dmgtime,dmgtime);
	if(dmgtime > get_gametime()) return HAM_IGNORED;
	
	// and boom goes the dynamite
	frostnade_explode(ent);

	return HAM_SUPERCEDE;
}

// a player_weaponstrip is used
public ham_player_weaponstrip_use(ent, idcaller, idactivator, use_type, Float:value)
{
	if(idcaller >= 1 && idcaller <= maxplayers)
	{
		// clear frostnade when using override
		hasFrostNade[idcaller] = 0;

		if(is_user_alive(idcaller) && get_pcvar_num(pcv_enabled) && get_pcvar_num(pcv_icon) == ICON_HASNADE)
		{
			new status = player_has_frostnade(idcaller);
			show_icon(idcaller, status);
		}
	}

	return HAM_IGNORED;
}

// some kind of grenade is deployed
public ham_grenade_deploy(ent, id)
{	
	if(pev_valid(ent))
	{
		grenade_deployed(get_pdata_cbase(ent, m_pPlayer, 4),
			get_pdata_int(ent, OFFSET_WEAPON_CSWID, 4));
		hasFrostNade[id] = 0
	}
	
	return HAM_IGNORED;
}

// some kind of grenade is holstered
public ham_grenade_holster(ent)
{
	if(pev_valid(ent))
	{
		grenade_holstered(get_pdata_cbase(ent, m_pPlayer, 4),
			get_pdata_int(ent, OFFSET_WEAPON_CSWID, 4));
	}
	
	return HAM_IGNORED;
}

// some kind of grenade is added to a player's inventory
public ham_grenade_addtoplayer(ent, id)
{
	if(pev_valid(ent))
	{
		grenade_added(id, get_pdata_int(ent, OFFSET_WEAPON_CSWID, 4));
	}

	return HAM_IGNORED;
}

// some kind of grenade is added to a player's inventory, when he already has one
public ham_grenade_addduplicate(ent, orig)
{
	if(pev_valid(orig))
	{
		grenade_added(pev(orig, pev_owner), get_pdata_int(orig, OFFSET_WEAPON_CSWID, 4));
	}
	
	return HAM_IGNORED;
}

// handle when player id deploys a grenade with weapon id wid
grenade_deployed(id, wid)
{
	// if we should worry about managing my icon now
	if(get_pcvar_num(pcv_enabled) && is_user_alive(id) && get_pcvar_num(pcv_icon) == ICON_HASNADE)
	{
		// if I just switched to a frost grenade
		if( wid == hasFrostNade[id]
			|| (get_pcvar_num(pcv_override) && (get_pcvar_num(pcv_teams) & _:fm_get_user_team(id)) && is_wid_in_nadetypes(wid)) )
		{
			show_icon(id, STATUS_FLASH);
		}
	}
}

// handle when player id holsters a grenade with weapon id wid
grenade_holstered(id, wid)
{	
	// if we should worry about managing my icon now
	if(get_pcvar_num(pcv_enabled) && is_user_alive(id) && get_pcvar_num(pcv_icon) == ICON_HASNADE)
	{
		// if I just holstered a frost grenade		
		if( wid == hasFrostNade[id]
			|| (get_pcvar_num(pcv_override) && (get_pcvar_num(pcv_teams) & _:fm_get_user_team(id)) && is_wid_in_nadetypes(wid)) )
		{
			// only do STATUS_SHOW or STATUS_HIDE... during holster, current weapon
			// will still technically be the frost grenade, but we don't want to
			// mistakenly flash the icon				
			new status = (player_has_frostnade(id) != STATUS_HIDE ? STATUS_SHOW : STATUS_HIDE);
			show_icon(id, status);
		}
	}
}

// handle when player id gets a grenade with weapon id wid added to his inventory
grenade_added(id, wid)
{
	// if we should worry about managing my icon now
	if(get_pcvar_num(pcv_enabled) && is_user_alive(id) && get_pcvar_num(pcv_icon) == ICON_HASNADE)
	{
		// if I just got a frost grenade
		if( wid == hasFrostNade[id]
			|| (get_pcvar_num(pcv_override) && (get_pcvar_num(pcv_teams) & _:fm_get_user_team(id)) && is_wid_in_nadetypes(wid)) )
		{
			new status = player_has_frostnade(id);
			show_icon(id, status);
		}
	}
}

// a frost grenade explodes
public frostnade_explode(ent)
{
	new nadeTeam = pev(ent,pev_team), owner = pev(ent,pev_owner), Float:nadeOrigin[3];
	pev(ent,pev_origin,nadeOrigin);
	
	// make the smoke
	message_begin_fl(MSG_PVS,SVC_TEMPENTITY,nadeOrigin,0);
	write_byte(TE_SMOKE);
	write_coord_fl(nadeOrigin[0]); // x
	write_coord_fl(nadeOrigin[1]); // y
	write_coord_fl(nadeOrigin[2]); // z
	write_short(smokeSpr); // sprite
	write_byte(random_num(30,40)); // scale
	write_byte(5); // framerate
	message_end();
	
	// explosion
	create_blast(nadeTeam,nadeOrigin);
	emit_sound(ent,CHAN_ITEM,SOUND_EXPLODE,VOL_NORM,ATTN_NORM,0,PITCH_HIGH);

	// cache our cvars
	new ff = get_pcvar_num(mp_friendlyfire), Float:by_radius = get_pcvar_float(pcv_by_radius),
			hitself = get_pcvar_num(pcv_hitself), los = get_pcvar_num(pcv_los), Float:maxdamage = get_pcvar_float(pcv_maxdamage),
			Float:mindamage = get_pcvar_float(pcv_mindamage), Float:chill_maxchance = get_pcvar_float(pcv_chill_maxchance),
			Float:chill_minchance = get_pcvar_float(pcv_chill_minchance), Float:freeze_maxchance, Float:freeze_minchance;

	if(!by_radius)
	{
		freeze_maxchance = get_pcvar_float(pcv_freeze_maxchance);
		freeze_minchance = get_pcvar_float(pcv_freeze_minchance);
	}

	new ta, Float:targetOrigin[3], Float:distance, tr = create_tr2(), Float:fraction, Float:damage, gotFrozen = 0;
	for(new target=1;target<=maxplayers;target++)
	{
		// dead, invincible, or self attack that is not allowed
		if(!is_user_alive(target) || pev(target,pev_takedamage) == DAMAGE_NO
		|| (pev(target,pev_flags) & FL_GODMODE) ||(target == owner && !hitself))
			continue;
		
		// this is a team attack with ff disabled, excluding self attack
		ta = (_:fm_get_user_team(target) == nadeTeam);
		if(ta && !ff && target != owner) continue;
		
		pev(target,pev_origin,targetOrigin);
		distance = vector_distance(nadeOrigin,targetOrigin);
		
		// too far
		if(distance > FROST_RADIUS) continue;

		// check line of sight
		if(los)
		{
			nadeOrigin[2] += 2.0;
			engfunc(EngFunc_TraceLine,nadeOrigin,targetOrigin,DONT_IGNORE_MONSTERS,ent,tr);
			nadeOrigin[2] -= 2.0;

			get_tr2(tr,TR_flFraction,fraction);
			if(fraction != 1.0 && get_tr2(tr,TR_pHit) != target) continue;
		}

		// damaged
		if(maxdamage > 0.0)
		{
			damage = radius_calc(distance,FROST_RADIUS,maxdamage,mindamage);
			if(ta) damage /= 2.0; // half damage for friendlyfire

			if(damage > 0.0)
			{
				frostKilled[target] = 1;
				ExecuteHamB(Ham_TakeDamage,target,ent,owner,damage,DMG_GRENADE);
				if(!is_user_alive(target)) continue; // dead now
				frostKilled[target] = 0;
			}
		}

		// frozen
		if((by_radius && radius_calc(distance,FROST_RADIUS,100.0,0.0) >= by_radius)
		|| (!by_radius && random_num(1,100) <= floatround(radius_calc(distance,FROST_RADIUS,freeze_maxchance,freeze_minchance))))
		{
			if(freeze_player(target,owner,nadeTeam))
			{
				gotFrozen = 1;
				emit_sound(target,CHAN_ITEM,SOUND_FROZEN,1.0,ATTN_NONE,0,PITCH_LOW);
			}
		}
		
		// chilled
		if(by_radius || random_num(1,100) <= floatround(radius_calc(distance,FROST_RADIUS,chill_maxchance,chill_minchance)))
		{
			if(chill_player(target,owner,nadeTeam))
			{
				if(!gotFrozen) emit_sound(target,CHAN_ITEM,SOUND_CHILLED,VOL_NORM,ATTN_NORM,0,PITCH_HIGH);
			}
		}
	}

	free_tr2(tr);
	set_pev(ent,pev_flags,pev(ent,pev_flags)|FL_KILLME);
}

freeze_player(id,attacker,nadeTeam)
{
	new fwdRetVal = PLUGIN_CONTINUE;
	ExecuteForward(fnFwdPlayerFrozen, fwdRetVal, id, attacker);
	
	if(fwdRetVal == PLUGIN_HANDLED || fwdRetVal == PLUGIN_HANDLED_MAIN)
	{
		return 0;
	}

	if(!isFrozen[id])
	{
		pev(id,pev_gravity,oldGravity[id]);

		// register our forward only when we need it
		if(!fmFwdPPT)
		{
			fmFwdPPT = register_forward(FM_PlayerPreThink,"fw_playerprethink",0);
		}
	}

	isFrozen[id] = nadeTeam;
	
	set_pev(id,pev_velocity,Float:{0.0,0.0,0.0});
	set_user_chillfreeze_speed(id);
	
	new Float:duration = get_pcvar_float(pcv_freeze_duration), Float:variance = get_pcvar_float(pcv_freeze_variance);
	duration += random_float(-variance,variance);

	remove_task(TASK_REMOVE_FREEZE+id);
	set_task(duration,"task_remove_freeze",TASK_REMOVE_FREEZE+id);
	
	if(!pev_valid(novaDisplay[id])) create_nova(id);
	
	if(get_pcvar_num(pcv_icon) == ICON_ISCHILLED)
	{
		show_icon(id, STATUS_FLASH);
	}
	
	return 1;
}

public task_remove_freeze(taskid)
{
	new id = taskid-TASK_REMOVE_FREEZE;
	
	if(pev_valid(novaDisplay[id]))
	{
		new Float:origin[3];
		pev(novaDisplay[id],pev_origin,origin);

		// add some tracers
		message_begin_fl(MSG_PVS,SVC_TEMPENTITY,origin,0);
		write_byte(TE_IMPLOSION);
		write_coord_fl(origin[0]); // x
		write_coord_fl(origin[1]); // y
		write_coord_fl(origin[2] + 8.0); // z
		write_byte(64); // radius
		write_byte(10); // count
		write_byte(3); // duration
		message_end();

		// add some sparks
		message_begin_fl(MSG_PVS,SVC_TEMPENTITY,origin,0);
		write_byte(TE_SPARKS);
		write_coord_fl(origin[0]); // x
		write_coord_fl(origin[1]); // y
		write_coord_fl(origin[2]); // z
		message_end();

		// add the shatter
		message_begin_fl(MSG_PAS,SVC_TEMPENTITY,origin,0);
		write_byte(TE_BREAKMODEL);
		write_coord_fl(origin[0]); // x
		write_coord_fl(origin[1]); // y
		write_coord_fl(origin[2] + 24.0); // z
		write_coord_fl(16.0); // size x
		write_coord_fl(16.0); // size y
		write_coord_fl(16.0); // size z
		write_coord(random_num(-50,50)); // velocity x
		write_coord(random_num(-50,50)); // velocity y
		write_coord_fl(25.0); // velocity z
		write_byte(10); // random velocity
		write_short(glassGibs); // model
		write_byte(10); // count
		write_byte(25); // life
		write_byte(BREAK_GLASS); // flags
		message_end();

		emit_sound(novaDisplay[id],CHAN_ITEM,SOUND_UNFROZEN,VOL_NORM,ATTN_NORM,0,PITCH_LOW);
		set_pev(novaDisplay[id],pev_flags,pev(novaDisplay[id],pev_flags)|FL_KILLME);
	}

	isFrozen[id] = 0;
	novaDisplay[id] = 0;
	
	// unregister forward if we are no longer using it
	unregister_prethink();

	if(!is_user_connected(id)) return;
	
	// restore speed, but then check for chilled
	ExecuteHam(Ham_Player_ResetMaxSpeed, id);
	set_user_chillfreeze_speed(id);

	set_pev(id,pev_gravity,oldGravity[id]);
	
	new status = STATUS_HIDE;
	
	// sometimes trail fades during freeze, reapply
	if(isChilled[id])
	{
		status = STATUS_SHOW;
		
		new rgb[3];
		get_rgb_colors(isChilled[id],rgb);
		set_beamfollow(id,30,8,rgb,100);
	}
	
	if(get_pcvar_num(pcv_icon) == ICON_ISCHILLED)
	{
		show_icon(id, status);
	}
}

chill_player(id,attacker,nadeTeam)
{
	new fwdRetVal = PLUGIN_CONTINUE;
	ExecuteForward(fnFwdPlayerChilled, fwdRetVal, id, attacker);
	
	if(fwdRetVal == PLUGIN_HANDLED || fwdRetVal == PLUGIN_HANDLED_MAIN)
	{
		return 0;
	}

	// we aren't already been chilled
	if(!isChilled[id])
	{
		oldRenderFx[id] = pev(id,pev_renderfx);
		pev(id,pev_rendercolor,oldRenderColor[id]);
		oldRenderMode[id] = pev(id,pev_rendermode);
		pev(id,pev_renderamt,oldRenderAmt[id]);

		isChilled[id] = nadeTeam; // fix -- thanks Exolent

		// register our forward only when we need it
		//if(!fmFwdPPT) fmFwdPPT = register_forward(FM_PlayerPreThink,"fw_playerprethink",0);
	}

	isChilled[id] = nadeTeam;
	
	set_user_chillfreeze_speed(id);
	
	new Float:duration = get_pcvar_float(pcv_chill_duration), Float:variance = get_pcvar_float(pcv_chill_variance);
	duration += random_float(-variance,variance);

	remove_task(TASK_REMOVE_CHILL+id);
	set_task(duration,"task_remove_chill",TASK_REMOVE_CHILL+id);

	new rgb[3];
	get_rgb_colors(nadeTeam,rgb);
	
	IVecFVec(rgb, glowColor[id]);
	
	// glowshell
	set_user_rendering(id, kRenderFxGlowShell, rgb[0], rgb[1], rgb[2], kRenderNormal, floatround(GLOW_AMOUNT));

	set_beamfollow(id,30,8,rgb,100);

	// I decided to let the frostnade tint override a flashbang,
	// because if you are frozen, then you have much bigger problems.

	// add a blue tint to their screen
	if(!is_user_connected(id))
		return 1;
		
	message_begin(MSG_ONE,gmsgScreenFade,_,id);
	write_short(floatround(4096.0 * duration)); // duration
	write_short(floatround(3072.0 * duration)); // hold time (4096.0 * 0.75)
	write_short(FFADE_IN); // flags
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	write_byte(100); // alpha
	message_end();
	
	if(get_pcvar_num(pcv_icon) == ICON_ISCHILLED && !isFrozen[id])
	{
		show_icon(id, STATUS_SHOW);
	}
	
	return 1;
}

public task_remove_chill(taskid)
{
	new id = taskid-TASK_REMOVE_CHILL;

	isChilled[id] = 0;
	
	// unregister forward if we are no longer using it
	//unregister_prethink();

	if(!is_user_connected(id)) return;
	
	// set speed to normal, then check for frozen
	ExecuteHam(Ham_Player_ResetMaxSpeed, id);
	set_user_chillfreeze_speed(id);

	// reset rendering
	set_user_rendering(id, oldRenderFx[id], floatround(oldRenderColor[id][0]), floatround(oldRenderColor[id][1]),
		floatround(oldRenderColor[id][2]), oldRenderMode[id], floatround(oldRenderAmt[id]));

	clear_beamfollow(id);

	// calculate end of flashbang
	new Float:flashedUntil = get_pdata_float(id,m_flFlashedUntil),
			Float:flashHoldTime = get_pdata_float(id,m_flFlashHoldTime),
			Float:endOfFlash = flashedUntil + (flashHoldTime * 0.67);
	
	// not blinded
	if(get_gametime() >= endOfFlash)
	{
		// clear tint
		if(!is_user_connected(id))
		return;
		message_begin(MSG_ONE,gmsgScreenFade,_,id);
		write_short(0); // duration
		write_short(0); // hold time
		write_short(FFADE_IN); // flags
		write_byte(0); // red
		write_byte(0); // green
		write_byte(0); // blue
		write_byte(255); // alpha
		message_end();
	}
	
	if(get_pcvar_num(pcv_icon) == ICON_ISCHILLED && !isFrozen[id])
	{
		show_icon(id, STATUS_HIDE);
	}
}

// make a frost nova at a player's feet
create_nova(id)
{
	new nova = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"info_target"));

	engfunc(EngFunc_SetSize,nova,Float:{-8.0,-8.0,-4.0},Float:{8.0,8.0,4.0});
	engfunc(EngFunc_SetModel,nova,MODEL_FROZEN);

	// random orientation
	new Float:angles[3];
	angles[1] = random_float(0.0,360.0);
	set_pev(nova,pev_angles,angles);

	// put it at their feet
	new Float:novaOrigin[3];
	pev(id,pev_origin,novaOrigin);
	engfunc(EngFunc_SetOrigin,nova,novaOrigin);

	// make it translucent
	new rgb[3];
	get_rgb_colors(isFrozen[id], rgb);
	IVecFVec(rgb, angles); // let's just use angles

	set_pev(nova,pev_rendercolor,angles); // see above
	set_pev(nova,pev_rendermode,kRenderTransAlpha);
	set_pev(nova,pev_renderfx,kRenderFxGlowShell);
	set_pev(nova,pev_renderamt,128.0);

	novaDisplay[id] = nova;
}

/****************************************
* UTILITY FUNCTIONS
****************************************/

// check if prethink is still being used, if not, unhook it
unregister_prethink()
{
	if(fmFwdPPT)
	{
		new i;
		for(i=1;i<=maxplayers;i++) if(/*isChilled[i] ||*/ isFrozen[i]) break;
		if(i > maxplayers)
		{
			unregister_forward(FM_PlayerPreThink,fmFwdPPT,0);
			fmFwdPPT = 0;
		}
	}
}

// make the explosion effects
create_blast(team,Float:origin[3])
{
	new rgb[3];
	get_rgb_colors(team,rgb);

	// smallest ring
	message_begin_fl(MSG_PVS,SVC_TEMPENTITY,origin,0);
	write_byte(TE_BEAMCYLINDER);
	write_coord_fl(origin[0]); // x
	write_coord_fl(origin[1]); // y
	write_coord_fl(origin[2]); // z
	write_coord_fl(origin[0]); // x axis
	write_coord_fl(origin[1]); // y axis
	write_coord_fl(origin[2] + 385.0); // z axis
	write_short(exploSpr); // sprite
	write_byte(0); // start frame
	write_byte(0); // framerate
	write_byte(4); // life
	write_byte(60); // width
	write_byte(0); // noise
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	write_byte(100); // brightness
	write_byte(0); // speed
	message_end();

	// medium ring
	message_begin_fl(MSG_PVS,SVC_TEMPENTITY,origin,0);
	write_byte(TE_BEAMCYLINDER);
	write_coord_fl(origin[0]); // x
	write_coord_fl(origin[1]); // y
	write_coord_fl(origin[2]); // z
	write_coord_fl(origin[0]); // x axis
	write_coord_fl(origin[1]); // y axis
	write_coord_fl(origin[2] + 470.0); // z axis
	write_short(exploSpr); // sprite
	write_byte(0); // start frame
	write_byte(0); // framerate
	write_byte(4); // life
	write_byte(60); // width
	write_byte(0); // noise
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	write_byte(100); // brightness
	write_byte(0); // speed
	message_end();

	// largest ring
	message_begin_fl(MSG_PVS,SVC_TEMPENTITY,origin,0);
	write_byte(TE_BEAMCYLINDER);
	write_coord_fl(origin[0]); // x
	write_coord_fl(origin[1]); // y
	write_coord_fl(origin[2]); // z
	write_coord_fl(origin[0]); // x axis
	write_coord_fl(origin[1]); // y axis
	write_coord_fl(origin[2] + 555.0); // z axis
	write_short(exploSpr); // sprite
	write_byte(0); // start frame
	write_byte(0); // framerate
	write_byte(4); // life
	write_byte(60); // width
	write_byte(0); // noise
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	write_byte(100); // brightness
	write_byte(0); // speed
	message_end();

	// light effect
	message_begin_fl(MSG_PAS,SVC_TEMPENTITY,origin,0);
	write_byte(TE_DLIGHT);
	write_coord_fl(origin[0]); // x
	write_coord_fl(origin[1]); // y
	write_coord_fl(origin[2]); // z
	write_byte(floatround(FROST_RADIUS/5.0)); // radius
	write_byte(rgb[0]); // r
	write_byte(rgb[1]); // g
	write_byte(rgb[2]); // b
	write_byte(8); // life
	write_byte(60); // decay rate
	message_end();
}

// give an entity a beam trail
set_beamfollow(ent,life,width,rgb[3],brightness)
{
	clear_beamfollow(ent);

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_BEAMFOLLOW);
	write_short(ent); // entity
	write_short(trailSpr); // sprite
	write_byte(life); // life
	write_byte(width); // width
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	write_byte(brightness); // brightness
	message_end();
}

// removes beam trails from an entity
clear_beamfollow(ent)
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_KILLBEAM);
	write_short(ent); // entity
	message_end();
}

// gets the appropriate color and displays the frostnade icon to the player with the given status
show_icon(id, status)
{
	static rgb[3];
	if(status) get_rgb_colors(_:fm_get_user_team(id), rgb); // only get colors if we need to
	
	if(!is_user_connected(id))
		return;
	message_begin(MSG_ONE,gmsgStatusIcon,_,id);
	write_byte(status); // status (0=hide, 1=show, 2=flash)
	write_string("dmg_cold"); // sprite name
	write_byte(rgb[0]); // red
	write_byte(rgb[1]); // green
	write_byte(rgb[2]); // blue
	message_end();
}

// checks if a weapon id is included in fn_nadetypes
is_wid_in_nadetypes(wid)
{
	new types = get_pcvar_num(pcv_nadetypes);
	
	return ( (wid == CSW_HEGRENADE && (types & NT_HEGRENADE))
		|| (wid == CSW_FLASHBANG && (types & NT_FLASHBANG))
		|| (wid == CSW_SMOKEGRENADE && (types & NT_SMOKEGRENADE)) );
}

// checks if a player has a frostnade, taking into account fn_override and such.
// returns: STATUS_HIDE = no frostnade, STATUS_SHOW = has frostnade but not deployed, STATUS_FLASH = has frostnade and deployed
player_has_frostnade(id)
{
	new retVal = STATUS_HIDE, curwpn = get_user_weapon(id);
	
	// no override, variable explicitly set
	if(hasFrostNade[id])
	{
		retVal = (curwpn == hasFrostNade[id] ? STATUS_FLASH : STATUS_SHOW);
	}
	
	// override enabled, and I'm on the right team
	else if(get_pcvar_num(pcv_override) && (get_pcvar_num(pcv_teams) & _:fm_get_user_team(id)))
	{		
		new types = get_pcvar_num(pcv_nadetypes);
					
		if((types & NT_HEGRENADE) && cs_get_user_bpammo(id, CSW_HEGRENADE) > 0)
		{
			retVal = (curwpn == CSW_HEGRENADE ? STATUS_FLASH : STATUS_SHOW);
		}
		
		if(retVal != STATUS_FLASH && (types & NT_FLASHBANG) && cs_get_user_bpammo(id, CSW_FLASHBANG) > 0)
		{
			retVal = (curwpn == CSW_FLASHBANG ? STATUS_FLASH : STATUS_SHOW);
		}
		
		if(retVal != STATUS_FLASH && (types & NT_SMOKEGRENADE) && cs_get_user_bpammo(id, NT_SMOKEGRENADE) > 0)
		{
			retVal = (curwpn == NT_SMOKEGRENADE ? STATUS_FLASH : STATUS_SHOW);
		}
	}
	
	return retVal;
}

// gets RGB colors from the cvar
get_rgb_colors(team,rgb[3])
{
	static color[12], parts[3][4];
	get_pcvar_string(pcv_color,color,11);
	
	// if cvar is set to "team", use colors based on the given team
	if(equali(color,"team",4))
	{
		if(team == 1)
		{
			rgb[0] = 150;
			rgb[1] = 0;
			rgb[2] = 0;
		}
		else
		{
			rgb[0] = 0;
			rgb[1] = 0;
			rgb[2] = 150;
		}
	}
	else
	{
		parse(color,parts[0],3,parts[1],3,parts[2],3);
		rgb[0] = str_to_num(parts[0]);
		rgb[1] = str_to_num(parts[1]);
		rgb[2] = str_to_num(parts[2]);
	}
}

// scale a value equally (inversely?) with the distance that something
// is from the center of another thing. that makes pretty much no sense,
// so basically, the closer we are to the center of a ring, the higher
// our value gets.
//
// EXAMPLE: distance = 60.0, radius = 240.0, maxVal = 100.0, minVal = 20.0
// we are 0.75 (1.0-(60.0/240.0)) of the way to the radius, so scaled with our
// values, it comes out to 80.0 (20.0 + (0.75 * (100.0 - 20.0)))
Float:radius_calc(Float:distance,Float:radius,Float:maxVal,Float:minVal)
{
	if(maxVal <= 0.0) return 0.0;
	if(minVal >= maxVal) return minVal;
	return minVal + ((1.0 - (distance / radius)) * (maxVal - minVal));
}

// sets a user's chilled/frozen speed if applicable
// (NOTE: does NOT reset his maxspeed if he is not chilled/frozen)
set_user_chillfreeze_speed(id)
{
	if(isFrozen[id])
	{
		set_user_maxspeed(id, 1.0);
	}
	else if(isChilled[id])
	{
		set_user_maxspeed(id, get_default_maxspeed(id)*(get_pcvar_float(pcv_chill_speed)/100.0));
	}
}

// gets the maxspeed a user should have, given his current weapon
stock Float:get_default_maxspeed(id)
{	
	new wEnt = get_pdata_cbase(id, m_pActiveItem), Float:result = 250.0;

	if(pev_valid(wEnt))
	{
		ExecuteHam(Ham_CS_Item_GetMaxSpeed, wEnt, result);
	}
	
	return result;
}

public give_score(id,level,cid) { 

	if (!cmd_access(id,level,cid,3)) 
		return PLUGIN_HANDLED 
	new arg[32], arg2[8], name2[32] 
	read_argv(1,arg,31) 
	read_argv(2,arg2,7) 
	get_user_name(id,name2,31) 

	new player = cmd_target(id,arg,0) 
	if (!player) return PLUGIN_HANDLED 
	
	score[player] += str_to_num(arg2), cmdSaveScore(player)

	new name[32] 
	get_user_name(player,name,31) 
	ChatColor(id, "%s %L",PREFIX,LANG_PLAYER,"GIVE_SCORE",name2,name, str_to_num(arg2))
	
	console_print(id,"Player %s has receieved %d score points.",name, str_to_num(arg2)) 
	
	return PLUGIN_HANDLED
}